﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CrmDemoCodeFirst {

  public class Queries {

    public void GetCategoriesByPrice (MyDbContext context) {

      var query = context.Products.Include("Category")
          .Where(p => p.Price > 20.0)
          .ToList();
        
      Console.WriteLine("Products with categories");
      Console.WriteLine();
      Console.WriteLine("{0,-10} | {1,-50} | {2}", "ProductID", "ProductName", "CategoryName");
      Console.WriteLine();
      foreach (var product in query) {
        Console.WriteLine("{0,-10} | {1,-50} | {2}", product.ProductID, product.ProductName, product.Category.CategoryName);
      }
    }

    public void GetOrdersSince2007(MyDbContext context) {

      var query = context.Companies
        .Join(context.Orders.Where(o => o.OrderDate >= new DateTime(2007, 1, 1)),
            c => c.CompanyID,
            o => o.Company.CompanyID,
            (c, o) => new {
              c.CompanyName,
              o.OrderID,
              o.OrderDate
            }).OrderBy(p => p.OrderID).Select(p => p);

      Console.WriteLine("Orders with companies");
      Console.WriteLine();
      Console.WriteLine("{0,-10} | {1,-35} | {2}", "OrderID", "CompanyName", "OrderDate");
      Console.WriteLine();
      foreach(var element in query) {
        Console.WriteLine("{0,-10} | {1,-35} | {2}", element.OrderID, element.CompanyName, element.OrderDate);
      }

    }

  }

}

